javax.ws.rs.core

## Interface Request

-     public interface Request

  An injectable helper for request processing, all methods throw an `IllegalStateException` if called outside the scope of a request (e.g. from a provider constructor). Precondition processing (see the `evaluatePreconditions` methods) can result in either a `null` return value to indicate that preconditions have been met and that the request should continue, or a non-`null` return value to indicate that preconditions were not met. In the event that preconditions were not met, the returned `ResponseBuilder` instance will have an appropriate status and will also include a `Vary` header if the `selectVariant(List)` method was called prior to to calling `evaluatePreconditions`. It is the responsibility of the caller to check the status and add additional metadata if required. E.g., see HTTP/1.1, section 10.3.5 for details of the headers that are expected to accompany a `304 Not Modified` response.
  Since:
    1.0
  Author:
    Paul Sandoz, Marc Hadley, Marek Potociar

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Response.ResponseBuilder` | `evaluatePreconditions()` Evaluate request preconditions for a resource that does not currently exist.
    `Response.ResponseBuilder` | `evaluatePreconditions(Date lastModified)` Evaluate request preconditions based on the passed in value.
    `Response.ResponseBuilder` | `evaluatePreconditions(Date lastModified, EntityTag eTag)` Evaluate request preconditions based on the passed in value.
    `Response.ResponseBuilder` | `evaluatePreconditions(EntityTag eTag)` Evaluate request preconditions based on the passed in value.
    `String` | `getMethod()` Get the request method, e.g.
    `Variant` | `selectVariant(List<Variant> variants)` Select the representation variant that best matches the request.

- - ### Method Detail

    - #### getMethod

          String getMethod()

      Get the request method, e.g. GET, POST, etc.
      Returns:
        the request method.
      See Also:
        `HttpMethod`

    - #### selectVariant

          Variant selectVariant(List<Variant> variants)

      Select the representation variant that best matches the request. Returns `null` in case there is no matching variant in the list.

      More explicit variants are chosen ahead of less explicit ones. A vary header is computed from the supplied list and automatically added to the response.

      Parameters:
        `variants` - a list of Variant that describe all of the available representation variants.
      Returns:
        the variant that best matches the request or `null` if there's no match.
      Throws:
        `IllegalArgumentException` - if variants is empty or `null`.
        `IllegalStateException` - if called outside the scope of a request.
      See Also:
        `Variant.VariantListBuilder`

    - #### evaluatePreconditions

          Response.ResponseBuilder evaluatePreconditions(EntityTag eTag)

      Evaluate request preconditions based on the passed in value.
      Parameters:
        `eTag` - an ETag for the current state of the resource
      Returns:
        `null` if the preconditions are met or a `ResponseBuilder` set with the appropriate status if the preconditions are not met. A returned `ResponseBuilder` will include an ETag header set with the value of eTag, provided none of the precondition evaluation has failed, in which case the ETag header would not be included and the status code of the returned `ResponseBuilder` would be set to `Response.Status.PRECONDITION_FAILED`.
      Throws:
        `IllegalArgumentException` - if eTag is `null`.
        `IllegalStateException` - if called outside the scope of a request.

    - #### evaluatePreconditions

          Response.ResponseBuilder evaluatePreconditions(Date lastModified)

      Evaluate request preconditions based on the passed in value.
      Parameters:
        `lastModified` - a date that specifies the modification date of the resource
      Returns:
        `null` if the preconditions are met or a `ResponseBuilder` set with the appropriate status if the preconditions are not met.
      Throws:
        `IllegalArgumentException` - if lastModified is `null`.
        `IllegalStateException` - if called outside the scope of a request.

    - #### evaluatePreconditions

          Response.ResponseBuilder evaluatePreconditions(Date lastModified,
                                                       EntityTag eTag)

      Evaluate request preconditions based on the passed in value.
      Parameters:
        `lastModified` - a date that specifies the modification date of the resource
        `eTag` - an ETag for the current state of the resource
      Returns:
        `null` if the preconditions are met or a `ResponseBuilder` set with the appropriate status if the preconditions are not met. A returned `ResponseBuilder` will include an ETag header set with the value of eTag, provided none of the precondition evaluation has failed, in which case the ETag header would not be included and the status code of the returned `ResponseBuilder` would be set to `Response.Status.PRECONDITION_FAILED`.
      Throws:
        `IllegalArgumentException` - if lastModified or eTag is `null`.
        `IllegalStateException` - if called outside the scope of a request.

    - #### evaluatePreconditions

          Response.ResponseBuilder evaluatePreconditions()

      Evaluate request preconditions for a resource that does not currently exist. The primary use of this method is to support the If-Match: * and If-None-Match: * preconditions.

      Note that both preconditions `If-None-Match: *` and `If-None-Match: something` will always be considered to have been met and it is the applications responsibility to enforce any additional method-specific semantics. E.g. a `PUT` on a resource that does not exist might succeed whereas a `GET` on a resource that does not exist would likely result in a 404 response. It would be the responsibility of the application to generate the 404 response.

      Returns:
        `null` if the preconditions are met or a `ResponseBuilder` set with the appropriate status if the preconditions are not met.
      Throws:
        `IllegalStateException` - if called outside the scope of a request.
      Since:
        1.1

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.